<?php
if( !defined( 'BILLING_MODULE' ) ) {
	die( "Hacking attempt!" );
}

Class Payment {
	var $doc = "https://rucode.cc/module-dle";
	var $server = 0;

	function Settings( $config ) 
	{
		$Form = [];
	
		$Form[] = [
			"Логин подключения:", 
			"Ваш персональный логин на сайте rucode.cc",
			"<input name=\"save_con[id]\" class=\"form-control\" type=\"text\" value=\"" . $config['id'] ."\">"
		];
		$Form[] = [
			"API key:", 
			"API ключ предоставленный Вашему магазину на rucode.cc", 
			"<input name=\"save_con[apikey]\" class=\"form-control\" type=\"text\" value=\"" . $config['apikey'] ."\">"
		];

		return $Form;
	}

	private function generateSign($params, $separator = ':')
	{
		$signature = implode(':', $params);

		return md5($signature);
	}

	function Form( $id, $config_payment, $invoice, $currency, $desc )
	{
	    global $config;

        $billing_config = require MODULE_DATA . '/config.php';

		$host = $_SERVER['HTTP_HOST'];
		$currency = 'RUB';
		
		$generateSign = $this->generateSign([
            $host,
            $config_payment['id'],
			(float)$invoice['invoice_pay'],
			$currency,
			$config_payment['apikey'],
			(int)$id
		]);

        $success_url = $config['http_home_url'] . 'billing.html/pay/ok';
        $fail_url = $config['http_home_url'] . 'billing.html/pay/bad';

        if( !$desc ) {
            $desc = 'Пополнение баланса пользователем ' . $invoice['invoice_user_name'].' на сумму ' . $invoice['invoice_get'] . ' ' . $currency;
        }

        return '<form method="get" id="paysys_form" action="https://rucode.cc/process?">
				<input type=hidden name="login" value="' . $config_payment['id'] . '">
				<input type=hidden name="sum" value="' . $invoice['invoice_pay'] . '">
				<input type=hidden name="order" value="' . $id . '">
				<input type=hidden name="sign" value="' . $generateSign . '">
				<input type=hidden name="curr" value="' . $currency . '">
				<input type=hidden name="desc" value="' . $desc . '">
				<input type=hidden name="success_url" value="' . $success_url . '">
				<input type=hidden name="fail_url" value="' . $fail_url . '">
				
				<input type="submit" name="process" class="bs_button" value="Оплатить" />
			</form>';
	}
	
	function check_id( $result ) 
	{
		return $result['intid'];
	}
	
	function check_ok( $result ) 
	{
		return 'OK' . $result['intid'];
	}
	
	function check_out( $result, $config, $invoice ) 
	{
		// LogError('result: ' . json_encode($result));
		// LogError('config: ' . json_encode($config));
		// LogError('invoice: ' . json_encode($invoice));
		
        $generateSign = $this->generateSign([
            $result['shop_login'],
            (int)$result['order'],
            (float)$result['amount'],
            $config['apikey']
        ]);
		// LogError('checksign: ' . json_encode($generateSign));
		
		if (!hash_equals(strtoupper($generateSign), strtoupper($result['sign']))) {
			return "Verifying the signature information about the payment failed!\n";
		}

		return 200;
	}
}

$Paysys = new Payment;